

        *********************    ***********************  
      ******      .                              .  ******
     ****     .  .   .  Init & Exit code     .        **** 
    ***   '         .                .   *** 
    **  .  .    . .                        .    . .      ** 
    **              written in a hurry for     . .       ** 
    ***  .  :   . .          .     *** 
     ****          #Amycoders' starfield compo      by **** 
      ******    .        morbid  
        *********************    ***********************   
                




        bsr     CloseWB         ; Flush view and disable multitasking
        bsr     OpenScreen      ; Set pointers and sync

        jsr     Starfield_init  ;Init starfield
        
**
************************************************************
************************************************************
**
**                    >>> M A I N <<<
**



        


Main    btst    #6,$bfe001
        beq     Exit
        
        
        
************************************************************


        bsr     DisplayScreen
        move	#$040,$dff180
        jsr     Starfield       ;call starfield (a0=Bitplane)
        move	#$000,$dff180
        bra     Main




        
**
************************************************************
**
**      Flush view & disable system
**


CloseWB

        movea.l 4.w,a6          ; exec base
        jsr     -132(a6)        ; Forbid
        jsr     -120(a6)        ; Disable
        lea     GfxName(pc),a1  ; graphics.library
        moveq   #0,d0           ; whatever verision
        jsr     -552(a6)        ; open it !
        move.l  d0,GfxBase      ; store gfxbase
        movea.l d0,a6           ; gfxbase in a6
        move.l  $22(a6),OldView ; store system view
        move.l  $26(a6),OldCop  ; store system copper
        sub.l   a1,a1
        jsr     -222(a6)        ; flush view (LoadView)
        jsr     -270(a6)        ; WaitTOF
        jsr     -270(a6)        ; twice for interlaced views
        move.w  $dff002,OldDMAcon   ; store old dma control register
        ori.w   #$8000,OldDMAcon  ; set bit #15
        move.w  #$7fff,$dff096
        move.w  #$8380,$dff096
        rts
        
        
GfxName dc.b 'graphics.library',0
        even
GfxBase dc.l 0
OldView dc.l 0
OldCop  dc.l 0
OldDMAcon dc.w 0

        cnop 0,4

**
*************************************************************
**
**      Display Screen
**

DisplayScreen

        movem.l d0-d1,-(sp)
        move.b  $bfe801,d0
.wait   cmp.b   $bfe801,d0
        beq.b   .wait
        
        move.l  screen_logical(pc),d0
        move.l  screen_physical(pc),screen_logical
        move.l  d0,screen_physical

        lea     copper_bpl,a0
        move.w  d0,6(a0)                ; lower part of bpl address
        swap    d0
        move.w  d0,2(a0)                ; higher word

        movea.l screen_logical(pc),a0   
        moveq   #0,d0
        move.l  #(320/32)*256-1,d1
.clear  move.l  d0,(a0)+                ; clear logical screen
        dbf     d1,.clear
        lea     -(320/8)*256(a0),a0     
        
        movem.l (sp)+,d0-d1
        rts


screen_physical dc.l 0
screen_logical dc.l 0

        
**
*************************************************************
**
**      Open Screen
**

OpenScreen
        
        lea     $dff000,a5
        move.l  #Copper,$80(a5)
        
        move.w  #$2c81,$08e(a5)         ; display window start pos
        move.w  #$2cc1,$090(a5)         ; display window stop pos
        move.w  #$0038,$092(a5)         ; data fetch start pos
        move.w  #$00d0,$094(a5)         ; data fetch stop pos

        move.l  #ScreenA,screen_logical
        move.l  #ScreenB,screen_physical
        bsr     DisplayScreen
        
        rts
        
**
**************************************************************
**
**      Open WB 
**

Exit
        lea     $dff000,a5
        move.w  #$7fff,$96(a5)          ; clear dmacon
        move.w  OldDMAcon(pc),$96(a5)   ; set old bits
        move.l  GfxBase(pc),a6          ; gfxbase in a6
        move.l  OldCop(pc),$80(a5)      ; restart old copperlist
        move.l  OldView(pc),a1
        jsr     -222(a6)                ; Load system view
        
        move.l  a6,a1
        move.l  4.w,a6
        jsr     -414(a6)                ; close graphics.library
        jsr     -126(a6)                ; Enable
        jsr     -138(a6)                ; Permit
        
        rts
        
        

************************************************************************

        section screens,bss_c
        
ScreenA ds.b (320*256)/8
ScreenB ds.b (320*256)/8

************************************************************************

        section copperlist,data_c

        
Copper  dc.l $01001000  ; bplcon0
        dc.l $01080000  ; bpl1mod
        dc.l $010a0000  ; bpl2mod
        dc.l $01800000  ; colour 0 = black
        dc.l $01820fff  ; colour 1 = white
                
copper_bpl
        dc.l $00e00000  ; bpl1pth
        dc.l $00e20000  ; bpl1ptl


        dc.l $fffffffe


**************************************************************************
**************************************************************************
**
**
**  Your starfield code starts here
**
**  Azure
**	
**  Done 15/22.6.97 
**
**  58 bytes
**
**  The routine is cycling the RND-numbers along the different
**  Z-depts. When Z=0 is reached, a new number is cycled in.
**  Stars out of the clipping range arent plotted
**
**************************************************************************
**************************************************************************


        section code,code       ;put your code here

*********************************************
** Do all initialisations here
*********************************************
SpeedOfStars=6
NoFlicker=0	;set this to one to avoid that flickering star
		;(2 bytes longer)
LimitZ=0	;set this to one to make the starfield looking a bit
		;better by limiting Z. (4 bytes longer)

Starfield_init:
a
b
        rts


*********************************************
** This routine is called once a frame
**
** The destination Bitplane is given in a0
*********************************************

Starfield:
c
	rol.l	d5,d5
	addq	#5,d5
	move.l	d5,d7
.lop1
	addq	#2,d6
	move.w	d7,d1
	rol.l	d7,d7
	addq	#5,d7
	move.w	d7,d2

	moveq	#127,d3
	moveq	#33,d4
f.lop2
	ext.l	d2
	divs.w	d6,d2		;optimized version of axis persp-trick
	cmp.w	d3,d2		;(4 bytes shorter) 
			
	bge.s	.out
	add.w	d3,d2
	bmi.s	.out
	exg.l	d1,d2
	add.b	d4,d3		;this will loop once
	bvs.s	.lop2
				
	mulu.w	#320,d2
	add.w	d1,d2			

	bfset	(a0){d2:1}	;d2 is row offset
					;d1 is x-pos
.out	
	and	#$3fe,d6
	bne.s	.lop1
d
        rts

	printt "Length of code:"
	printv ((b-a)+(d-c))

        section bss,bss         ;put your tables heres

